#[allow(unused_mut)]
fn main() {
    // Аллоцируем 40 байт на куче
    let xs = vec![0; 10];
    // Мы можем передать владение другой переменной, добавив мутабельность
    let mut ys = xs;
    // После передачи владения, обращаться к xs нельзя
    // Error: borrow of moved value: `xs`
    // println!("{}", xs[0]);

    // Владение можно передать в функцию
    print_vec(ys);
    // Можно получить из функции
    let mut numbers = get_even_numbers(5);
    // Если мы хотим скопировать, а не передать, то надо звать .clone()
    let numbers_copy = numbers.clone();
    // Мы можем сразу избавиться от объекта, передав его в drop
    drop(numbers_copy);

    // Вместо передачи владения, объекты можно одалживать.
    let numbers_ref = &numbers;
    println!("{}", numbers_ref[0]);
    // Аналогично можно отдавать ссылки в функции
    println!("{}", sum(&numbers));
    // Так же можно возвращать ссылки, если они переживают объекты, на которые ссылаются
    let first_elem = get_first_elem(&numbers);
    println!("{}", first_elem);
    // Мы не можем поменять или отдать объект, пока на него существуют ссылки
    // numbers.push() может привести к релокации массива, что инвалидирует ссылку
    // numbers.clear() гарантированно уничтожит объект, на который идёт ссылка
    // если менять отдельные элементы, то ничего страшного не произойдёт, но
    // компилятор этого не понимает и не даёт менят совсем

    // Мы можем также брать мьютабельную ссылку, если объект мьютабеьный
    let mut_ref = &mut numbers;
    // Создание мьютабельной ссылки инвалидирует все ссуществующие ссылки
    // при вызове методов часто не важно, вызывать их от объекта или от ссылки, но
    // при присвоение важно указать, меняется объект или ссылка
    *mut_ref = get_even_numbers(10);

    // Слайсы являются разновидностью ссылок и подчиняются тем же правилам
    // Получить слайс по вектору можно так:
    let slice = &mut numbers[..];
    slice[0] = 2;
}

fn print_vec(v: Vec<i32>) {
    println!("{:?}", v);
}

fn get_even_numbers(len: usize) -> Vec<i32> {
    (1..).filter(|x| x % 2 == 0).take(len).collect()
}

fn sum(v: &Vec<i32>) -> i32 {
    v.iter().sum()
}

fn get_first_elem(v: &Vec<i32>) -> &i32 {
    &v[0]
}
